io.vertx.core.net

## Interface NetSocket

- All Superinterfaces:
    ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public interface NetSocket
      extends ReadStream<Buffer>, WriteStream<Buffer>

  Represents a socket-like interface to a TCP connection on either the client or the server side.

  Instances of this class are created on the client side by an `NetClient` when a connection to a server is made, or on the server side by a `NetServer` when a server accepts a connection.

  It implements both `ReadStream` and `WriteStream` so it can be used with `Pump` to pump data with flow control.

  Author:
    Tim Fox

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close the NetSocket
    `NetSocket` | `closeHandler(Handler<Void> handler)` Set a handler that will be called when the NetSocket is closed
    `NetSocket` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Calls `close()`
    `NetSocket` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `NetSocket` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `NetSocket` | `handler(Handler<Buffer> handler)` Set a data handler.
    `boolean` | `isSsl()`
    `SocketAddress` | `localAddress()`
    `NetSocket` | `pause()` Pause the `ReadSupport`.
    `X509Certificate[]` | `peerCertificateChain()`
    `SocketAddress` | `remoteAddress()`
    `NetSocket` | `resume()` Resume reading.
    `default NetSocket` | `sendFile(String filename)` Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `default NetSocket` | `sendFile(String filename, Handler<AsyncResult<Void>> resultHandler)` Same as `sendFile(String)` but also takes a handler that will be called when the send has completed or a failure has occurred
    `default NetSocket` | `sendFile(String filename, long offset)` Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `default NetSocket` | `sendFile(String filename, long offset, Handler<AsyncResult<Void>> resultHandler)` Same as `sendFile(String, long)` but also takes a handler that will be called when the send has completed or a failure has occurred
    `NetSocket` | `sendFile(String filename, long offset, long length)` Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `NetSocket` | `sendFile(String filename, long offset, long length, Handler<AsyncResult<Void>> resultHandler)` Same as `sendFile(String, long, long)` but also takes a handler that will be called when the send has completed or a failure has occurred
    `NetSocket` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `NetSocket` | `upgradeToSsl(Handler<Void> handler)` Upgrade channel to use SSL/TLS.
    `NetSocket` | `write(Buffer data)` Write some data to the stream.
    `NetSocket` | `write(String str)` Write a `String` to the connection, encoded in UTF-8.
    `NetSocket` | `write(String str, String enc)` Write a `String` to the connection, encoded using the encoding `enc`.
    `String` | `writeHandlerID()` When a `NetSocket` is created it automatically registers an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, writeQueueFull`

- - ### Method Detail

    - #### exceptionHandler

          NetSocket exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          NetSocket handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          NetSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadSupport`. While it's paused, no data will be sent to the `dataHandler`
      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          NetSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading. If the `ReadSupport` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          NetSocket endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          NetSocket write(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          NetSocket setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` bytes in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          NetSocket drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue has been reduced to maxSize / 2. See `Pump` for an example of this being used.
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeHandlerID

          String writeHandlerID()

      When a `NetSocket` is created it automatically registers an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

      Given this ID, a different event loop can send a buffer to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other connections which are owned by different event loops.

      Returns:
        the write handler ID

    - #### write

          NetSocket write(String str)

      Write a `String` to the connection, encoded in UTF-8.
      Parameters:
        `str` - the string to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          NetSocket write(String str,
                          String enc)

      Write a `String` to the connection, encoded using the encoding `enc`.
      Parameters:
        `str` - the string to write
        `enc` - the encoding to use
      Returns:
        a reference to this, so the API can be used fluently

    - #### sendFile

          default NetSocket sendFile(String filename)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
      Returns:
        a reference to this, so the API can be used fluently

    - #### sendFile

          default NetSocket sendFile(String filename,
                                     long offset)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
      Returns:
        a reference to this, so the API can be used fluently

    - #### sendFile

          NetSocket sendFile(String filename,
                             long offset,
                             long length)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
        `length` - length
      Returns:
        a reference to this, so the API can be used fluently

    - #### sendFile

          default NetSocket sendFile(String filename,
                                     Handler<AsyncResult<Void>> resultHandler)

      Same as `sendFile(String)` but also takes a handler that will be called when the send has completed or a failure has occurred
      Parameters:
        `filename` - file name of the file to send
        `resultHandler` - handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### sendFile

          default NetSocket sendFile(String filename,
                                     long offset,
                                     Handler<AsyncResult<Void>> resultHandler)

      Same as `sendFile(String, long)` but also takes a handler that will be called when the send has completed or a failure has occurred
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
        `resultHandler` - handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### sendFile

          NetSocket sendFile(String filename,
                             long offset,
                             long length,
                             Handler<AsyncResult<Void>> resultHandler)

      Same as `sendFile(String, long, long)` but also takes a handler that will be called when the send has completed or a failure has occurred
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
        `length` - length
        `resultHandler` - handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### remoteAddress

          SocketAddress remoteAddress()

      Returns:
        the remote address for this socket

    - #### localAddress

          SocketAddress localAddress()

      Returns:
        the local address for this socket

    - #### end

          void end()

      Calls `close()`
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### close

          void close()

      Close the NetSocket

    - #### closeHandler

          NetSocket closeHandler(Handler<Void> handler)

      Set a handler that will be called when the NetSocket is closed
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### upgradeToSsl

          NetSocket upgradeToSsl(Handler<Void> handler)

      Upgrade channel to use SSL/TLS. Be aware that for this to work SSL must be configured.
      Parameters:
        `handler` - the handler will be notified when it's upgraded
      Returns:
        a reference to this, so the API can be used fluently

    - #### isSsl

          boolean isSsl()

      Returns:
        true if this `NetSocket` is encrypted via SSL/TLS.

    - #### peerCertificateChain

          X509Certificate[] peerCertificateChain()
                                          throws SSLPeerUnverifiedException

      Returns:
        an array of the peer certificates. Returns null if connection is not SSL.
      Throws:
        `SSLPeerUnverifiedException` - SSL peer's identity has not been verified.

Copyright © 2016. All rights reserved.